# -*- coding: UTF-8 -*-
#  icd_menu_open.py 2023.11.22  kita

#!! 公開スクリプトの起動メニュー icd_cam_open.py 追加

# 2023.12.16    icd_part_rename.py 追加 
# 2024. 3.11    icd_cam_open.py 追加


# ICADを操るためのおまじない
import clr
clr.AddReference('sxnet')
from sxnet import *

import tkinter as tk
from tkinter import *
from tkinter import messagebox

import numpy as np
import icd_module as imd
import my_vector as myv
import my_module as mmd
import os
import threading
from time import sleep
import sys
import subprocess
import my_tk as mtk


#sys.path.append("..")   # 親ディレクトリー 親directry 上のパス 上のフォルダー

pi= np.pi
my_fn= os.path.basename(__file__)       # icd_*.py
save_fn= my_fn.replace('.py','.dat')    # icd_*.dat


def get_ent():
    arr= entry[0].get().split(',')
    v_std= np.array([float(arr[0]),float(arr[1])])
    arr= entry[1].get().split(',')
    p00= np.array([float(arr[0]),float(arr[0])])
    dvl_r= float(entry[2].get())
    arr= entry[3].get().split(',')
    y0= float(arr[0])
    ly= float(arr[1])

    print(v_std, p00, dvl_r, y0, ly)
    return (v_std, p00, dvl_r, y0, ly)


#  Entry取得
def get_ent():
    nn_ent= len(entry_txt)
    for i in range(nn_ent):
        entry_txt[i]= entry[i].get()
        print(entry_txt[i]) ####
    return entry_txt



def set_ent_data():     # save_fnよりEntry detaを読み込んで書き込み
    fp = open(save_fn, 'r')
    lines = fp.readlines()
    fp.close()
    i= 0
    for line in lines:
        line = line.rstrip()    # 行末の改行削除
        if line.find('#') > -1:  # #が含まれてるなら
            continue

        tmp = line.split('= ')
        #print(line) #!!!!
        if line.find('entry') > -1: # Entry行
            #if len(tmp) == 2: 
            set_entry(i, tmp[1])
            i+= 1

def set_entry(idx, ss): # Entryに文字列を挿入
    entry[idx].delete(0,tk.END)
    entry[idx].insert(0,ss)

def set_entry2(ent, ss): # Entryに文字列を挿入
    ent.delete(0,tk.END)
    ent.insert(0,ss)


def save_ent_data():    # Entry 設定値保存
    ss = ''
    for i in range(len(entry)):
        #print(i)
        ss = ss + 'entry[%d]= %s\n' % (i, entry[i].get())

    fp = open(save_fn,'w')
    fp.write(ss)
    fp.close()    

#----------------------------------------- 
#   各種スクリプト起動関数
#----------------------------------------- 

# Active Model操作
def act_mdl_opr():
    cmd = 'py icd_cur_mdl_opr.py'
    result = subprocess.Popen(cmd,shell=True)

# ボルト配置    
def bolt_set():
    cmd = 'py icd_bolt_set.py'    # 
    result = subprocess.Popen(cmd,shell=True)

def make_plan():
    cmd = 'py icd_make_plan.py'    # 
    result = subprocess.Popen(cmd,shell=True)

def bulk_import():
    cmd = 'py icd_import.py'    # 
    result = subprocess.Popen(cmd,shell=True)

def mirror():
    cmd = 'py icd_mirror.py'    # 
    result = subprocess.Popen(cmd,shell=True)

def part_rename():
    cmd = 'py icd_part_rename.py'    # 
    result = subprocess.Popen(cmd,shell=True)



#------------------
# ２D操作関係
#------------------
def dim_edit():
    cmd = 'py icd_dim_edit.py'    # 
    result = subprocess.Popen(cmd,shell=True)

def radial_cl():
    cmd = 'py icd_radial_cl.py'    # 
    result = subprocess.Popen(cmd,shell=True)

def tenkaizu():
    cmd = 'py icd_tenkaizu.py'    # 
    result = subprocess.Popen(cmd,shell=True)

def gear():
    cmd = 'py icd_gear.py'    # 
    result = subprocess.Popen(cmd,shell=True)


def grp():
    cmd = 'py icd_grp.py'    # 
    result = subprocess.Popen(cmd,shell=True)

def search_word():
    word= entry[0].get()
    #print(word)
    cmd = 'py icd_search_word.py %s' % word    # 
    result = subprocess.Popen(cmd,shell=True)
    ss_msg= '%s の検索を終了しました' % word
    mtk.information(ss_msg)
    #print('\n    文字列の検索を終了しました\n\n')

#------------------
# その他
#------------------
def config_save():
    cmd = 'py icd_config_save.py'    # 
    result = subprocess.Popen(cmd,shell=True)

def read_menu():
    cmd = 'py icd_read_menu.py'    # 
    result = subprocess.Popen(cmd,shell=True)


def cam_open():
    cmd = 'py icd_cam_open.py'    # 
    result = subprocess.Popen(cmd,shell=True)

# 終了時の処理
def on_closing():       # 終了時の処理
    save_ent_data()
    ss_geom = root.geometry() 
    mmd.save_geometry(save_fn_geom, ss_geom)

    #print('\n   %s を終了しました\n' % tmp_fn)
    print('\n   %s を終了しました\n' % my_fn)

    root.destroy()


#************************************
# ボタン等の部品配置
#************************************
nl = 9
root = tk.Tk()
root.attributes("-topmost", True)    # 常に前面に表示
root.configure(bg='RoyalBlue4')
root.title(my_fn)  #タイトル
save_fn_geom = my_fn.replace('.py', '.ini')
ss_geom = mmd.read_geometry(save_fn_geom)
if ss_geom == None:
    ss_geom = '380x%d+1000+0' % (nl*26)

root.geometry(ss_geom)

btn_bcol = 'grey21'     #ボタン背景色
btn_tcol = 'white'      #ボタン文字色
label_bcol = 'khaki3'   #ラベル背景色
label_tcol = 'black'    #ラベル文字色
e_bcol = 'ivory2'       #Entry背景色

x0= 10; y0= 2
dx= 100; dy= 22
px= 2; py= 2
ie=0

# Frame1 3D作図関係
frame1 = tk.LabelFrame(root, text='3DModeling関係', padx=px, pady=py,bg="RoyalBlue3",fg=btn_tcol) 
frame1.place(x=x0,y=y0)
ss_list=['ActiveModel操作','ボルト配置','組立平面作成','ミラー反転','一括インポート','外部パーツリネーム']
btn_list=[act_mdl_opr, bolt_set, make_plan, mirror, bulk_import, part_rename] 
nn= len(ss_list)
i= 0
ie= 0; entry= []
for ss in ss_list:
    btn= tk.Button(frame1,text = ss, command= btn_list[i], bg=btn_bcol,fg=btn_tcol)    
    btn.grid(column=0,row=i, padx=px, pady=py)
    i+= 1

# Frame2 2D作図関係
frame2 = tk.LabelFrame(root, text='2D作図関係', padx=px, pady=py,bg="RoyalBlue3",fg=btn_tcol) 
frame2.place(x=x0+120,y=y0)
ss_list=['寸法編集','中心線再配置','展開図作成補助','ギヤ面作成','グリッパ開閉カム','文字列検索']
btn_list=[dim_edit, radial_cl, tenkaizu, gear, grp, search_word] 
nn= len(ss_list)
i= 0
for ss in ss_list:
    btn= tk.Button(frame2,text= ss, command= btn_list[i], bg=btn_bcol,fg=btn_tcol)    
    btn.grid(column=0,row=i, padx=px, pady=py)
    i+= 1
# Entry配置    
entry.append(tk.Entry(frame2, width=12,justify="right",bg=e_bcol)) 
entry[ie].grid(column=0,row=i, padx=px, pady=py)

# Frame3 その他
frame3 = tk.LabelFrame(root, text='その他', padx=px, pady=py,bg="RoyalBlue3",fg=btn_tcol) 
frame3.place(x=x0+235,y=y0)
ss_list=['iCAD環境設定保存','iCAD読込メニュー','カム関係メニュー']
btn_list=[config_save, read_menu, cam_open] 
nn= len(ss_list)
i= 0
for ss in ss_list:
    btn= tk.Button(frame3,text= ss, command= btn_list[i], bg=btn_bcol,fg=btn_tcol)    
    btn.grid(column=0,row=i, padx=px, pady=py)
    i+= 1

root.protocol("WM_DELETE_WINDOW", on_closing)
root.mainloop()

